#include <owl\applicat.h>
#include <owl\framewin.h>
#include "pr47_1.rc"

// .
class TApp: public TApplication
{
  public:
	 TApp():TApplication() {}
	 void InitMainWindow();
};

//     .
class TWndw : public  TFrameWindow
{
  public:
    TWndw (TWindow *parent, const char far *title);
  protected:
    int  childX, childY;
    void CmOpen(); 
    void CmClose();

    DECLARE_RESPONSE_TABLE (TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TFrameWindow)
	EV_COMMAND (CM_OPEN, CmOpen),
	EV_COMMAND (CM_CLOSE, CmClose),
END_RESPONSE_TABLE;

// TWndw::TWndw()
//    .
TWndw::TWndw(TWindow *parent, const char far *title):
          TFrameWindow (parent, title) 
{
  //     .
  Attr.X = 20;
  Attr.Y = 20;
  Attr.W = 500;
  Attr.H = 400;
  //    . 
  AssignMenu(MENU_1);
  //     .
  childX = 75; 
  childY = 75;
} 

// TWndw::CmOpen()
//   ,  
//   Open   File.
//     .
void TWndw::CmOpen() 
{
  //    .
  TWindow *child = new TWindow (this, " ");
  //   . 
  child->Attr.Style = WS_VISIBLE | WS_POPUPWINDOW | WS_CAPTION;
  //      . 
  child->Attr.X = childX; 
  child->Attr.Y = childY; 
  child->Attr.W = 200; 
  child->Attr.H = 150;
  //  . 
  child->Create();
  //    . 
  childX += 40; 
  if (childX > 400) childX = 75;
  childY += 40; 
  if (childY > 300) childX = 75;
}

// CloseTheWindow()
//  ForEach   ,  
//     .
void CloseTheWindow (TWindow *window, void*) 
{
  window->ShutDownWindow();
}

// TWndw::CmClose()
//      Close All  
// File,   ForEach    
//     TWndw. 
void TWndw::CmClose() 
{
  ForEach(CloseTheWindow);
}
 
void TApp::InitMainWindow()
{
  TFrameWindow *wndw = new TWndw (0,"  "); 
  SetMainWindow(wndw);
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
